class QueueNode(object):
    def __init__(self, value, prev, nxt):
        self.value = value
        self.next = nxt
        self.prev = prev

    def __repr__(self):
        nval = self.next and self.next.value or None
        pval = self.prev and self.prev.value or None
        return f"[{repr(pval)}, {self.value}, {repr(nval)}]"


class Queue(object):
    def __init__(self):
        self.begin = None
        self.end = None

    def count(self):
        """
        Returns number of items.
        Regresa la cantidad de ítems.
        """
        count = 0
        node = self.begin
        while node:
            count += 1
            node = node.next
        return count

    def unshift(self):
        """
        Removes the first item and returns its value.
        Remueve el primer ítem y regresa su valor.
        """
        if self.begin is None:
            value = None
        else:
            value = self.begin.value
            if self.begin == self.end:
                self.begin = self.end = None
            else:
                self.begin = self.begin.next
                self.begin.prev = None
        return value

    def shift(self, obj):
        """
        Appends a new item on the begin of the list.
        Añade un nuevo ítem al inicio de la lista.
        """
        node = QueueNode(obj, None, self.begin)
        if self.begin is None:
            self.begin = node
            self.end = self.begin
        else:
            self.begin.prev = node
            self.begin = node

    def top(self):
        """
        Returns value of first item.
        Regresa el valor del primer ítem.
        """
        return self.begin.value

    def bottom(self):
        """
        Returns value of last item.
        Regresa el valor del último ítem.
        """
        return self.end.value
