from queue import Queue


def test_unshift():
    colors = Queue()
    colors.shift("Viridian")
    colors.shift("Sap Green")
    colors.shift("Van Dyke")
    assert colors.unshift() == "Van Dyke"
    assert colors.unshift() == "Sap Green"
    assert colors.unshift() == "Viridian"
    assert colors.unshift() is None
    assert colors.count() == 0


def test_shift():
    colors = Queue()
    colors.shift("Cadmium Orange")
    assert colors.count() == 1
    colors.shift("Carbazole Violet")
    assert colors.count() == 2
    assert colors.unshift() == "Carbazole Violet"
    assert colors.count() == 1
    assert colors.unshift() == "Cadmium Orange"
    assert colors.count() == 0


def test_top():
    colors = Queue()
    colors.shift("Cadmium Red Light")
    assert colors.top() == "Cadmium Red Light"
    colors.shift("Hansa Yellow")
    assert colors.top() == "Hansa Yellow"
    colors.shift("Pthalo Green")
    assert colors.top() == "Pthalo Green"


def test_bottom():
    colors = Queue()
    colors.shift("Cadmium Red Light")
    assert colors.bottom() == "Cadmium Red Light"
    colors.shift("Hansa Yellow")
    assert colors.bottom() == "Cadmium Red Light"
    colors.shift("Pthalo Green")
    assert colors.bottom() == "Cadmium Red Light"
